



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Unity3d在Window上使用SAPI进行语音识别</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Unity3d在Window上使用SAPI进行语音识别</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-18 20:43:07 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>前言</h3>
<p>在之前《<a href="http://www.cnblogs.com/CodeGize/p/5419396.html" rel="external nofollow noreferrer"><strong>Unity</strong><strong>利用</strong><strong>Sapi</strong><strong>进行</strong><strong>windows</strong><strong>语音开发</strong></a>》中，本计划不准备继续做语音识别。因为在unity3d中已经提供了语音识别的相关方法，详见unity3d的官方文档：<a href="https://docs.unity3d.com/ScriptReference/Windows.Speech.KeywordRecognizer.html" rel="external nofollow noreferrer">https://docs.unity3d.com/ScriptReference/Windows.Speech.KeywordRecognizer.html</a>。但是有一点是这个只支持win10。对于win7用户来说，如果不使用百度语音或者科大讯飞语音的话，那么使用SAPI就是最好的方式了。同样的，由于Unity中无法直接使用SAPI，所以只能按照原来的思路，把它写到一个exe工具中，然后再由unity3d来调用。</p>
<h3>工程变更和重构</h3>
<p>还是继续之前的工程，但是为了规范一些，我把工程名称从SpeechTest改为了Speech。并且重构了Socket通信结构，将原本的SocketExtra分为了SocketBase，SocketServer和SocketClient。这样做的目的就是简单化，并且增加SocketServer发送信息到SocketClient的功能。</p>
<p>这是工程的最终结构图</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/289969/201703/289969-20170330165750992-2094130810.jpg" /></p>
<h3>通信数据结构</h3>
<p>由于speech加入了语音识别功能，所以为了区别之前的通信信息，重新整理定义了新的通信数据结构。通信数据结构定为二进制数据，前4位是一个int32型的命令码，这些命令码有不同的含义和内容：</p>
<ul><li>1：表示初始化，</li>
<li>2：表示文字转语音，后面紧跟着一个string</li>
<li>3：表示语音识别，后面是一个int32型，0表示结束识别，1表示开始识别</li></ul>
<p>当speech收到1时，进行初始化。收到2的信息时，读取之后的文本数据，然后交由Speecher来发音。收到3时，读取后面的数据，如果是1，则开始进行录音识别，如果是0则停止录音识别。</p>
<p>Speech代码NetServer.cs</p>
<div>
<pre class="prettyprint linenums">        public bool NetReciveMsg(byte[] recivebuffer, int netID)<br />
        {<br />
            var arg = new ByteOutArg(recivebuffer);<br />
            var cmd = arg.ReadInt32();<br />
            switch ((EmCmd)cmd)<br />
            {<br />
                case EmCmd.Init:<br />
                    Init();<br />
                    break;<br />
                case EmCmd.Speak:<br />
                    var str = arg.ReadString();<br />
                    Console.WriteLine(str);<br />
                    m_speecher.Speak(str);<br />
                    return true;<br />
                case EmCmd.Recognize:<br />
                    var scmd = arg.ReadInt32();<br />
                    if (scmd == )<br />
                        m_recognizer.BeginRec();<br />
                    if (scmd == )<br />
                        m_recognizer.EndRec();<br />
                    return true;<br />
                default:<br />
                    throw new ArgumentOutOfRangeException();<br />
            }<br />
            return false;<br />
        }</pre>
</div>
<p>在unity发送的代码。（ByteInArg是一个简单地写如byte[]数据的类）</p>
<div>
<pre class="prettyprint linenums">/***测试代码，可删除Start***/

    public void OnGUI()<br />
    {<br />
        if (GUILayout.Button("Connect"))<br />
        {<br />
            StartCoroutine(Connect());<br />
        }<br />
        if (GUILayout.Button("InitServer"))<br />
        {<br />
            StartCoroutine(InitServer());<br />
        }

        if (GUILayout.Button("Speak"))<br />
        {<br />
            Speak("hello world");<br />
        }

        if (GUILayout.Button("Recognize Start"))<br />
        {<br />
            Recognize(true);<br />
        }<br />
        if (GUILayout.Button("Recognize End"))

        {<br />
            Recognize(false);<br />
        }<br />
    }

    /***测试代码，可删除End***/

    private void Recognize(bool tf)<br />
    {<br />
        var arg = new ByteInArg();<br />
        arg.Write();<br />
        arg.Write(tf ?  : );<br />
        NetSendMsg(arg.GetBuffer());<br />
    }

    public IEnumerator Connect()<br />
    {<br />
        m_socket = new SocketClient(this);<br />
        m_socket.Connect("127.0.0.1", );<br />
        while (!m_socket.Connected)<br />
        {<br />
            yield return ;<br />
        }<br />
    }

    public IEnumerator InitServer()<br />
    {<br />
        var arg = new ByteInArg();<br />
        arg.Write();<br />
        NetSendMsg(arg.GetBuffer());<br />
        yield return ;<br />
    }

    public void Speech(string str)<br />
    {<br />
        if (m_socket.Connected)<br />
        {<br />
            var arg = new ByteInArg();<br />
            arg.Write();<br />
            arg.Write(str);<br />
            //var bytes = Encoding.Default.GetBytes(str);<br />
            NetSendMsg(arg.GetBuffer());<br />
        }<br />
    }</pre>
</div>
<h3>封装SAPI语音识别模块</h3>
<p>封装SAPI的语音识别模块这方面的代码很多，也比较简单。这里创建的Recognizer类，代码更改自<a href="http://kevin19900306.iteye.com/blog/1206534" rel="external nofollow noreferrer">http://kevin19900306.iteye.com/blog/1206534</a>，其中的含义可以查阅SAPI的相关文档。Recognizer类有构造函数，两个接口，一个回调向外提供。这两个接口为开始识别BeginRec和停止识别EndRec，当识别完成时，使用回调，将识别的文字传出。</p>
<p>在speech的NetServer.cs中，回调相关的代码如下</p>
<div>
<pre class="prettyprint linenums">        public void Init()<br />
        {<br />
            m_speecher = new Speecher();<br />
            m_recognizer = new Recognizer<br />
            {<br />
                OnRecognized = OnRecognized<br />
            };<br />
            Console.WriteLine("初始化完成");<br />
        }

        private void OnRecognized(string text)<br />
        {<br />
            var arg = new ByteInArg();<br />
            arg.Write(text);<br />
            NetSendMsg(arg.GetBuffer());<br />
        }</pre>
</div>
<h3>测试</h3>
<p>运行unity3d，画面中出现5个按钮，分别为Connect，InitServer，Speak，Recognize Start，Recognize End。依次点击Connect，InitServer。然后点击Speak，听到&ldquo;hello world&rdquo;语音。点击Recognize Start，对麦克风说任何中文，可以看到debug输出对应的文字。点击Recognize End停止识别。</p>
<h3>Github源代码</h3>
<p>源代码下载<a href="https://github.com/CodeGize/UnitySapi/" rel="external nofollow noreferrer">https://github.com/CodeGize/UnitySapi/</a></p>
<h3>转载声明</h3>
<p>转载请保留</p>
<p><a href="http://www.codegize.com" rel="external nofollow noreferrer">www.codegize.com</a>,</p>
<p><a href="http://www.cnblogs.com/CodeGize/" rel="external nofollow noreferrer">www.cnblogs.com/CodeGize/</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8krmk6q.html">WebStorm 9 自动编译 LESS 产出 CSS 和 source maps</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdzzx48.html">PostgreSQL 中定义自己需要的数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y46n0q.html">iOS开发多线程--技术方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd4yyz8.html">ubuntu 中文界面下中文文件夹改英文</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvo0zoq.html">ASP&period;NET全局文件与防盗链</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm0p5k9.html">淘宝分布式数据层：TDDL&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1y5579.html">Delphi中动态创建的Panel无法改变颜色的解决办法（要把Panel的ParentBackground设为False）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o6zjj9.html">test md</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yovw08.html">Ruby学习： 类的定义和实例变量</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gemegz8.html">Appium  命令行启动配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yxdzz8.html">boost&colon;&colon;asio网络传输错误码的一些实验结果（recv error&lowbar;code）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gerlj78.html">Flex布局学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1m3wyq.html">JS（作用域和闭包）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g0jpzq.html">Spark-shell错误：Missing Python executable &amp;&num;39&semi;python&amp;&num;39&semi;&comma; defaulting to &period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwkpj48.html">php xml操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwv521r8.html">Setup ActorComponents</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllxdw1q.html">&lbrack;20170622&rsqb;传输表空间与dblink&period;txt</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn1rl2q.html">BZOJ&period;4072&period;&lbrack;SDOI2016&rsqb;征途&lpar;DP 斜率优化&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vp136q.html">idea忽略文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p3jr08.html">Java对象的内存&lpar;一&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qxko0gz8.html">java多线程安全问题 静态函数的修饰</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxko07j8.html">Android注解学习&lpar;2&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j0dwx8.html">读书笔记 effective c&plus;&plus; Item 11 在operator&equals;中处理自我赋值</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj0jp38.html">BZOJ 1062&colon; &lbrack;NOI2008&rsqb;糖果雨&lpar;二维树状数组&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rg05gr8.html">关于H5里的API，上传图片预览功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mer4o8.html">支持缩放的fresco图片控件 &mdash;&mdash; fresco sample&colon; ZoomableDraweeView</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4znpw39.html">MJRefresh在UITableView中的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp5mpj9.html">&lbrack;Selenium With C&num;学习笔记&rsqb; Lesson-03 超级链接</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpo5p7q.html">C&num;开发step步骤条控件</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2j0mev8.html">sass、less、stylus的安装及使用</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
